CREATE TABLE company(
	company_id INTEGER NOT NULL,
	town_id INTEGER, /* временно сняли, пока неясность с адресами*/
    address_id INTEGER,
    company_billingcode VARCHAR(50),
	company_name VARCHAR(350) NOT NULL,
    company_fullname VARCHAR(512) NOT NULL,
	company_address VARCHAR(255) NOT NULL,
    company_telefon VARCHAR(50),
    company_email VARCHAR(100),
    company_web VARCHAR(100),
	company_remark VARCHAR(255),
	company_upddate TIMESTAMP NOT NULL,
    company_duplicate int4 NOT NULL,
    company_blockflag int4 NOT NULL,
    company_physicalperson int4 NOT NULL,
    company_bank int4 NOT NULL,
    company_addressfact VARCHAR(200) NOT NULL,
    townfact_id int4 NOT NULL,
    CONSTRAINT company_pk PRIMARY KEY (company_id)
);
CREATE SEQUENCE company_id_gen AS INTEGER START WITH 1 INCREMENT BY 1;
ALTER SEQUENCE company_id_gen OWNED BY company.company_id;

CREATE TABLE mycompany (
    company_id int4 NOT NULL,
    CONSTRAINT mycompany_pk PRIMARY KEY (company_id),
    CONSTRAINT mycompany_fk1 FOREIGN KEY (company_id) REFERENCES company(company_id)
);

CREATE TABLE companybranch (
    company_id int4 NOT NULL,
    companymain_id int4 NOT NULL,
    CONSTRAINT companybranch_pk PRIMARY KEY (company_id),
    CONSTRAINT companybranch_fk1 FOREIGN KEY (company_id) REFERENCES company(company_id),
    CONSTRAINT companybranch_fk2 FOREIGN KEY (companymain_id) REFERENCES company(company_id)
);

CREATE TABLE companycode (
     COMPANY_ID INTEGER NOT NULL,
     COMPANYCODE_OKONX VARCHAR(20),
     COMPANYCODE_OKPO VARCHAR(20),
     COMPANYCODE_KPP VARCHAR(20),
     COMPANYCODE_OGRN VARCHAR(20),
     CONSTRAINT COMPANYCODE_PK PRIMARY KEY (COMPANY_ID),
     CONSTRAINT COMPANYCODE_FK1 FOREIGN KEY (COMPANY_ID) REFERENCES COMPANY(COMPANY_ID)
);

CREATE VIEW ft_company
AS
SELECT
	company_id,
	CAST(
		coalesce(company_billingcode,'')||' '||trim(company_name)||' '||trim(company_fullname)||' '||trim(company_address)||' '||coalesce(company_telefon,'')||' '||coalesce(company_email,'')||' '||coalesce(company_web,'')||' '||coalesce(company_remark,'')
		AS varchar(1971)
	) AS fulltext
FROM company;

