CREATE TABLE streettype (
    streettype_id int4 NOT NULL,
    streettype_name varchar(50) NOT NULL,
    streettype_code varchar(10) NOT NULL,
    CONSTRAINT streetstype_ak1 UNIQUE (streettype_name),
    CONSTRAINT streetstype_ak2 UNIQUE (streettype_code),
    CONSTRAINT streettype_pk PRIMARY KEY (streettype_id)
);


CREATE TABLE street(
	street_id INTEGER NOT NULL,
	town_id INTEGER NOT NULL,
	streettype_id INTEGER NOT NULL,
	street_name VARCHAR(50) NOT NULL,
	street_code VARCHAR(20) NOT NULL,
	street_aoid VARCHAR(36),
	street_aoguid VARCHAR(36),
	street_upddate TIMESTAMP NOT NULL,
    CONSTRAINT street_pk PRIMARY KEY (street_id)
);
CREATE SEQUENCE street_id_gen AS INTEGER START WITH 1 INCREMENT BY 1;
ALTER SEQUENCE street_id_gen OWNED BY street.street_id;
ALTER TABLE street ADD UNIQUE (street_code);

CREATE VIEW ft_street
AS
SELECT
	street_id,
	CAST(
		trim(street_name)||' '||trim(street_code)
		AS varchar(239)
	) AS fulltext
FROM street;

INSERT INTO streettype (streettype_id,streettype_name,streettype_code) VALUES
(-1,'',''),
(1,'УЛИЦА','УЛ'),
(2,'ПЕРЕУЛОК','ПЕР'),
(3,'ПРОСПЕКТ','ПР-КТ');